nxt.ms

## Class MonetarySystemTransactionType<Att extends Attachment.AbstractAttachment>

- java.lang.Object
- - nxt.blockchain.TransactionType
  - - nxt.blockchain.ChildTransactionType
    - - nxt.ms.MonetarySystemTransactionType<Att>

-     public abstract class MonetarySystemTransactionType<Att extends Attachment.AbstractAttachment>
      extends ChildTransactionType

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static TransactionType` | `CURRENCY_DELETION`
    `static TransactionType` | `CURRENCY_ISSUANCE`
    `static TransactionType` | `CURRENCY_MINTING`
    `static TransactionType` | `CURRENCY_TRANSFER`
    `static TransactionType` | `EXCHANGE_BUY`
    `static TransactionType` | `EXCHANGE_SELL`
    `static TransactionType` | `PUBLISH_EXCHANGE_OFFER`
    `static TransactionType` | `RESERVE_CLAIM`
    `static TransactionType` | `RESERVE_INCREASE`

    - ### Fields inherited from class nxt.blockchain.ChildTransactionType

      `TYPE_ACCOUNT_CONTROL, TYPE_ACCOUNT_PROPERTY, TYPE_ALIASES, TYPE_ASSET_EXCHANGE, TYPE_COIN_EXCHANGE, TYPE_DATA, TYPE_DIGITAL_GOODS, TYPE_LIGHT_CONTRACT, TYPE_MESSAGING, TYPE_MONETARY_SYSTEM, TYPE_PAYMENT, TYPE_SHUFFLING, TYPE_VOTING`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `checkLiquid(ChildTransactionImpl transaction)`
    `static TransactionType` | `findTransactionType(byte subtype)`
    `byte` | `getType()`
    `boolean` | `isDuplicate(Transaction transaction, java.util.Map<TransactionType,java.util.Map<java.lang.String,java.lang.Integer>> duplicates)`
    `boolean` | `isGlobal()`
    `void` | `validateAttachment(ChildTransactionImpl transaction)`
    `protected abstract void` | `validateAttachment(ChildTransactionImpl transaction, Att attachment)`

    - ### Methods inherited from class nxt.blockchain.ChildTransactionType

      `apply, applyAttachment, applyAttachment, applyAttachmentUnconfirmed, applyAttachmentUnconfirmed, applyUnconfirmed, findTransactionType, getBaselineFee, undoAttachmentUnconfirmed, undoAttachmentUnconfirmed, undoUnconfirmed, validateAttachment, validateId, validateId`

    - ### Methods inherited from class nxt.blockchain.TransactionType

      `canHaveRecipient, getBaselineFeeHeight, getLedgerEvent, getName, getNextFee, getNextFeeHeight, getSubtype, isBlockDuplicate, isDuplicate, isDuplicate, isPhasable, isPhasingSafe, isPruned, isUnconfirmedDuplicate, mustHaveRecipient, parseAttachment, parseAttachment, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### CURRENCY_ISSUANCE

          public static final TransactionType CURRENCY_ISSUANCE

    - #### RESERVE_INCREASE

          public static final TransactionType RESERVE_INCREASE

    - #### RESERVE_CLAIM

          public static final TransactionType RESERVE_CLAIM

    - #### CURRENCY_TRANSFER

          public static final TransactionType CURRENCY_TRANSFER

    - #### PUBLISH_EXCHANGE_OFFER

          public static final TransactionType PUBLISH_EXCHANGE_OFFER

    - #### EXCHANGE_BUY

          public static final TransactionType EXCHANGE_BUY

    - #### EXCHANGE_SELL

          public static final TransactionType EXCHANGE_SELL

    - #### CURRENCY_MINTING

          public static final TransactionType CURRENCY_MINTING

    - #### CURRENCY_DELETION

          public static final TransactionType CURRENCY_DELETION

  - ### Method Detail

    - #### findTransactionType

          public static TransactionType findTransactionType(byte subtype)

    - #### validateAttachment

          public final void validateAttachment(ChildTransactionImpl transaction)
                                        throws NxtException.ValidationException

      Specified by:
        `validateAttachment` in class `ChildTransactionType`
      Throws:
        `NxtException.ValidationException`

    - #### checkLiquid

          protected void checkLiquid(ChildTransactionImpl transaction)
                              throws NxtException.NotCurrentlyValidException

      Throws:
        `NxtException.NotCurrentlyValidException`

    - #### validateAttachment

          protected abstract void validateAttachment(ChildTransactionImpl transaction,
                                                     Att attachment)
                                              throws NxtException.ValidationException

      Throws:
        `NxtException.ValidationException`

    - #### getType

          public final byte getType()

      Specified by:
        `getType` in class `TransactionType`

    - #### isDuplicate

          public boolean isDuplicate(Transaction transaction,
                                     java.util.Map<TransactionType,java.util.Map<java.lang.String,java.lang.Integer>> duplicates)

      Overrides:
        `isDuplicate` in class `TransactionType`

    - #### isGlobal

          public final boolean isGlobal()

      Specified by:
        `isGlobal` in class `TransactionType`